# -*- coding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2012 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

from osv import fields, osv

class hr_payslip(osv.osv):
    _inherit = 'hr.payslip'
    _columns = {}

    def process_sheet(self, cr, uid, ids, context=None):
        move_line_pool = self.pool.get('account.move.line')
        res = super(hr_payslip, self).process_sheet(cr, uid, ids, context=context)
        for slip in self.browse(cr, uid, ids, context=context):
            employee_partner_id = slip.employee_id.partner_id and slip.employee_id.partner_id.id or False
            if slip.move_id and employee_partner_id:
                line_ids = slip.move_id.line_id
                for line in line_ids:
                    if line.account_id.employee_partner:
                        move_line_pool.write(cr, uid, line.id, {'partner_id': employee_partner_id}, context=context)
        return res

hr_payslip()

class account_account(osv.osv):
    _inherit = 'account.account'
    _columns = {
        'employee_partner': fields.boolean('Get the employee partner?', help='If checked, when you will validate your payslip and there is a move line defined on this account, the partner will be automatically filled by the employee\'s partner'),
    }
account_account()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
