#-*- coding:utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _
import unicodedata

list_data = ['-','/',' ','!','*',':','+','(',')','[',']','{','}',"'"]

class hr_payroll_configuration(osv.osv_memory):
    _name = 'hr.payroll.configuration'
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
    }

    _defaults = {
        'company_id': lambda self,cr,uid,c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
    }
    
    def update_code(self, name, add=''):
        code = name.upper() + add.upper()
        code = unicodedata.normalize('NFKD', code).encode('ascii', 'ignore')
        for val in list_data:
            code = code.replace(val,'_')
        return code

    def get_categories(self, cr, uid, context=None):
        if context is None:
            context = {}

        categories_dict = {}
        model_data_obj = self.pool.get('ir.model.data')

        ded_categ = model_data_obj._get_id(cr, uid, 'hr_payroll', 'DED')
        ded_categ_id = model_data_obj.browse(cr, uid, ded_categ).res_id
        categories_dict['ded_categ'] = ded_categ_id

        ded_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'DED_EMPLOYEE')
        ded_employee_categ_id = model_data_obj.browse(cr, uid, ded_employee_categ).res_id
        categories_dict['ded_employee_categ'] = ded_employee_categ_id

        ded_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'DED_EMPLOYER')
        ded_employer_categ_id = model_data_obj.browse(cr, uid, ded_employer_categ).res_id
        categories_dict['ded_employer_categ'] = ded_employer_categ_id

        net_categ = model_data_obj._get_id(cr, uid, 'hr_payroll', 'NET')
        net_categ_id = model_data_obj.browse(cr, uid, net_categ).res_id
        categories_dict['net_categ'] = net_categ_id

        net_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'NET_EMPLOYEE')
        net_employee_categ_id = model_data_obj.browse(cr, uid, net_employee_categ).res_id
        categories_dict['net_employee_categ'] = net_employee_categ_id

        net_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'NET_EMPLOYER')
        net_employer_categ_id = model_data_obj.browse(cr, uid, net_employer_categ).res_id
        categories_dict['net_employer_categ'] = net_employer_categ_id

        ss_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS')
        ss_categ_id = model_data_obj.browse(cr, uid, ss_categ).res_id
        categories_dict['ss_categ'] = ss_categ_id

        ss_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS_EMPLOYEE')
        ss_employee_categ_id = model_data_obj.browse(cr, uid, ss_employee_categ).res_id
        categories_dict['ss_employee_categ'] = ss_employee_categ_id

        ss_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS_EMPLOYER')
        ss_employer_categ_id = model_data_obj.browse(cr, uid, ss_employer_categ).res_id
        categories_dict['ss_employer_categ'] = ss_employer_categ_id

        ss4_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS4')
        ss4_categ_id = model_data_obj.browse(cr, uid, ss4_categ).res_id
        categories_dict['ss4_categ'] = ss4_categ_id

        ss4_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS4_EMPLOYEE')
        ss4_employee_categ_id = model_data_obj.browse(cr, uid, ss4_employee_categ).res_id
        categories_dict['ss4_employee_categ'] = ss4_employee_categ_id

        ss4_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SS4_EMPLOYER')
        ss4_employer_categ_id = model_data_obj.browse(cr, uid, ss4_employer_categ).res_id
        categories_dict['ss4_employer_categ'] = ss4_employer_categ_id

        smic_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SMIC')
        smic_categ_id = model_data_obj.browse(cr, uid, smic_categ).res_id
        categories_dict['smic_categ'] = smic_categ_id

        smic_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SMIC_EMPLOYEE')
        smic_employee_categ_id = model_data_obj.browse(cr, uid, smic_employee_categ).res_id
        categories_dict['smic_employee_categ'] = smic_employee_categ_id

        smic_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SMIC_EMPLOYER')
        smic_employer_categ_id = model_data_obj.browse(cr, uid, smic_employer_categ).res_id
        categories_dict['smic_employer_categ'] = smic_employer_categ_id

        more_smic_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'DEP_SMIC')
        more_smic_categ_id = model_data_obj.browse(cr, uid, more_smic_categ).res_id
        categories_dict['more_smic_categ'] = more_smic_categ_id

        more_smic_employee_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'DEP_SMIC_EMPLOYEE')
        more_smic_employee_categ_id = model_data_obj.browse(cr, uid, more_smic_employee_categ).res_id
        categories_dict['more_smic_employee_categ'] = more_smic_employee_categ_id

        more_smic_employer_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'DEP_SMIC_EMPLOYER')
        more_smic_employer_categ_id = model_data_obj.browse(cr, uid, more_smic_employer_categ).res_id
        categories_dict['more_smic_employer_categ'] = more_smic_employer_categ_id

        sup_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'INTER_SUP')
        sup_categ_id = model_data_obj.browse(cr, uid, sup_categ).res_id
        categories_dict['sup_categ'] = sup_categ_id

        supp1_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SUP1')
        supp1_categ_id = model_data_obj.browse(cr, uid, supp1_categ).res_id
        categories_dict['supp1_categ'] = supp1_categ_id

        supp2_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SUP2')
        supp2_categ_id = model_data_obj.browse(cr, uid, supp2_categ).res_id
        categories_dict['supp2_categ'] = supp2_categ_id

        normal_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'NORMAL')
        normal_categ_id = model_data_obj.browse(cr, uid, normal_categ).res_id
        categories_dict['normal_categ'] = normal_categ_id

        adjustment_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'ADJUSTMENT')
        adjustment_categ_id = model_data_obj.browse(cr, uid, adjustment_categ).res_id
        categories_dict['adjustment_categ'] = adjustment_categ_id

        sup1_nb_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SUP1_NB')
        sup1_nb_categ_id = model_data_obj.browse(cr, uid, sup1_nb_categ).res_id
        categories_dict['sup1_nb_categ'] = sup1_nb_categ_id

        sup2_nb_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'SUP2_NB')
        sup2_nb_categ_id = model_data_obj.browse(cr, uid, sup2_nb_categ).res_id
        categories_dict['sup2_nb_categ'] = sup2_nb_categ_id

        normal_nb_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'NORMAL_NB')
        normal_nb_categ_id = model_data_obj.browse(cr, uid, normal_nb_categ).res_id
        categories_dict['normal_nb_categ'] = normal_nb_categ_id

        adjustment_nb_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'ADJUSTMENT_NB')
        adjustment_nb_categ_id = model_data_obj.browse(cr, uid, adjustment_nb_categ).res_id
        categories_dict['adjustment_nb_categ'] = adjustment_nb_categ_id

        total_nb_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'TOTAL_NB')
        total_nb_categ_id = model_data_obj.browse(cr, uid, total_nb_categ).res_id
        categories_dict['total_nb_categ'] = total_nb_categ_id

        holidays_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'HOLIDAYS')
        holidays_categ_id = model_data_obj.browse(cr, uid, holidays_categ).res_id
        categories_dict['holidays_categ'] = holidays_categ_id

        expense_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'EXPENSE')
        expense_categ_id = model_data_obj.browse(cr, uid, expense_categ).res_id
        categories_dict['expense_categ'] = expense_categ_id

        advance_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'ADVANCE')
        advance_categ_id = model_data_obj.browse(cr, uid, advance_categ).res_id
        categories_dict['advance_categ'] = advance_categ_id

        indemnity_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'INDEMNITY')
        indemnity_categ_id = model_data_obj.browse(cr, uid, indemnity_categ).res_id
        categories_dict['indemnity_categ'] = indemnity_categ_id
        
        indemnity_on_gross_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'INDEMNITY_ON_GROSS')
        indemnity_on_gross_categ_id = model_data_obj.browse(cr, uid, indemnity_on_gross_categ).res_id
        categories_dict['indemnity_on_gross_categ'] = indemnity_on_gross_categ_id

        return categories_dict

    def create_brut_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                        ('code', '=', data.debit_account.code)
                                    ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                        ('code', '=', data.credit_account.code)
                                    ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        if data.employee_rate:
            seq += 1
            employee_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employee_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.BASIC',
                'amount_percentage': data.employee_rate,
                'account_debit': False,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employee': True,
            }, context=context)
        if data.employer_rate:
            seq += 1
            employer_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employer_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.BASIC',
                'amount_percentage': data.employer_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employer': True,
            }, context=context)
        return seq
    
    def get_rate_name(self, cr, uid, rate, context=None):
        rate_name = ''
        int_rate = int(rate)
        if int_rate >= 0:
            if int_rate < 10:
                rate_name = '00' + str(int_rate)
            elif int_rate < 100:
                rate_name = '0' + str(int_rate)
            else:
                rate_name = str(int_rate)
        if not int_rate == rate:
            rest_name = str(round(rate-int(rate),6))
            rate_name += rest_name.split('.')[1]
        return rate_name
    
    def create_normal_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')
        
        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                        ('code', '=', data.debit_account.code)
                                    ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                        ('code', '=', data.credit_account.code)
                                    ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        normal_categ_id = rule_categories['normal_categ']
        rate = data.employee_rate
        rate_name = self.get_rate_name(cr, uid, rate, context=context)
        normal_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line,
            'name_to_print_on_line': data.name_to_print_on_line,
            'category_id': normal_categ_id,
            'sequence': 1,
#            'condition_select': 'python',
#            'condition_python': 'result = worked_days.WORK' + rate_name,
#            'amount_select': 'code',
#            'amount_python_compute': 'result = contract.wage\nresult_qty = worked_days.WORK' + rate_name + '.number_of_hours\nresult_rate = ' + str(rate),
            'condition_select': 'python',
            'condition_python': 'result = worked_days.WORK' + rate_name + ' and worked_days.WORK' + rate_name + '.number_of_hours or worked_days.WORK' + rate_name + '_ADJUST and worked_days.WORK' + rate_name + '_ADJUST.number_of_hours',
            'amount_select': 'code',
            'amount_python_compute': 'result = contract.wage\nresult_qty = (worked_days.WORK' + rate_name + ' and worked_days.WORK' + rate_name + '.number_of_hours or 0) + (worked_days.WORK' + rate_name + '_ADJUST and worked_days.WORK' + rate_name + '_ADJUST.number_of_hours or 0)\nresult_rate = ' + str(rate),
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'hour': True,
        }, context=context)
#        adjustment_categ_id = rule_categories['adjustment_categ']
#        adjustment_rule_id = rule_obj.create(cr, uid, {
#            'name': _('Adjustment ') + data.name,
#            'code': _('Adjustment ') + data.name_to_print_on_line,
#            'name_to_print_on_line': _('Adjustment ') + data.name_to_print_on_line,
#            'category_id': adjustment_categ_id,
#            'sequence': 4,
#            'condition_select': 'python',
#            'condition_python': 'result = worked_days.WORK' + rate_name + '_ADJUST',
#            'amount_select': 'code',
#            'amount_python_compute': 'result = contract.wage\nresult_qty = worked_days.WORK' + rate_name + '_ADJUST.number_of_hours\nresult_rate = ' + str(rate),
#            'account_debit': account_debit_id,
#            'account_credit': account_credit_id,
#            'account_tax_id': account_tax_id,
#            'hour': True,
#        })
        
        normal_nb_categ_id = rule_categories['normal_nb_categ']
        rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'NORMAL' + rate_name + '_NB',
            'name_to_print_on_line': data.name_to_print_on_line,
            'category_id': normal_nb_categ_id,
            'sequence': 1,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.WORK' + rate_name,
            'amount_select': 'percentage',
            'amount_percentage_base': 'worked_days.WORK' + rate_name + '.number_of_hours',
            'amount_percentage': 100,
            'account_debit': False,
            'account_credit': False,
            'appears_on_payslip': False,
        }, context=context)
        adjustment_nb_categ_id = rule_categories['adjustment_nb_categ']
        rule_obj.create(cr, uid, {
            'name': _('Adjustment ') + data.name,
            'code': _('Adjustment ') + 'NORMAL' + rate_name + '_NB',
            'name_to_print_on_line': _('Adjustment ') + data.name_to_print_on_line,
            'category_id': adjustment_nb_categ_id,
            'sequence': 4,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.WORK' + rate_name + '_ADJUST',
            'amount_select': 'percentage',
            'amount_percentage_base': 'worked_days.WORK' + rate_name + '_ADJUST.number_of_hours',
            'amount_percentage': 100,
            'account_debit': False,
            'account_credit': False,
            'appears_on_payslip': False,
        }, context=context)
        return seq

    def create_csg_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                    ('code', '=', data.credit_account.code)
                                                ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        if data.employee_rate:
            employee_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employee_categ_id,
                'sequence': 175,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.BASIC * config.CSG.value',
                'amount_percentage': data.employee_rate,
                'account_debit': False,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employee': True,
            }, context=context)

        if data.employer_rate:
            employer_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employer_categ_id,
                'sequence': 175,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.BASIC * config.CSG.value',
                'amount_percentage': data.employer_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employer': True,
            }, context=context)
        return seq

    def create_csg_ss(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        if data.base == 'ss':
            seq += 1
            ss_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
                'name_to_print_on_line': data.name_to_print_on_line,
                'appears_on_payslip': False,
                'category_id': rule_categories['ss_categ'],
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'code',
                'amount_python_compute': 'result = min(config.SS.value, categories.BASIC)',
            }, context=context)

            if data.employee_rate:
                seq += 1
                ss_employee_rule_id = rule_obj.create(cr, uid, {
                    'name': data.name,
                    'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                    'name_to_print_on_line': data.name_to_print_on_line,
                    'category_id': employee_categ_id,
                    'sequence': seq,
                    'condition_select': 'none',
                    'amount_select': 'percentage',
                    'amount_percentage_base': 'categories.SS',
                    'amount_percentage': data.employee_rate,
                    'account_debit': False,
                    'account_credit': account_credit_id,
                    'account_tax_id': account_tax_id,
                    'employee': True,
                }, context=context)
            if data.employer_rate:
                seq += 1
                ss_employer_rule_id = rule_obj.create(cr, uid, {
                    'name': data.name,
                    'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                    'name_to_print_on_line': data.name_to_print_on_line,
                    'category_id': employer_categ_id,
                    'sequence': seq,
                    'condition_select': 'none',
                    'amount_select': 'percentage',
                    'amount_percentage_base': 'categories.SS',
                    'amount_percentage': data.employer_rate,
                    'account_debit': account_debit_id,
                    'account_credit':  account_credit_id,
                    'account_tax_id': account_tax_id,
                    'employer': True,
                }, context=context)
        else:
            seq += 1
            ss4_rule_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
                'name_to_print_on_line': data.name_to_print_on_line,
                'appears_on_payslip': False,
                'category_id': rule_categories['ss4_categ'],
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'code',
                'amount_python_compute': 'result = min(config.SS.value * 4, categories.BASIC)',
            }, context=context)

            if data.employee_rate:
                seq += 1
                ss4_employee_rule_id = rule_obj.create(cr, uid, {
                    'name': data.name,
                    'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                    'name_to_print_on_line': data.name_to_print_on_line,
                    'category_id': employee_categ_id,
                    'sequence': seq,
                    'condition_select': 'none',
                    'amount_select': 'percentage',
                    'amount_percentage_base': 'categories.SS4',
                    'amount_percentage': data.employee_rate,
                    'account_debit': False,
                    'account_credit': account_credit_id,
                    'account_tax_id': account_tax_id,
                    'employee': True,
                }, context=context)
            if data.employer_rate:
                seq += 1
                ss4_employer_rule_id = rule_obj.create(cr, uid, {
                    'name': data.name,
                    'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                    'name_to_print_on_line': data.name_to_print_on_line,
                    'category_id': employer_categ_id,
                    'sequence': seq,
                    'condition_select': 'none',
                    'amount_select': 'percentage',
                    'amount_percentage_base': 'categories.SS4',
                    'amount_percentage': data.employer_rate,
                    'account_debit': account_debit_id,
                    'account_credit':  account_credit_id,
                    'account_tax_id': account_tax_id,
                    'employer': True,
                }, context=context)
        return seq

    def create_smic_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                 ('code', '=', data.debit_account.code)
                                             ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        seq += 1
        smic_inter_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': False,
            'category_id': rule_categories['smic_categ'],
            'sequence': seq,
            'condition_select': 'none',
            'amount_select': 'code',
            'amount_python_compute': 'result = min(worked_days.WORK100.number_of_hours * config.SMIC.value, categories.BASIC)',
        }, context=context)
        if data.employee_rate:
            seq += 1
            smic_employee_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employee_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.SMIC',
                'amount_percentage': data.employee_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employee': True,
            }, context=context)
        if data.employer_rate:
            seq += 1
            smic_employer_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employer_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.SMIC',
                'amount_percentage': data.employer_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employer': True,
            }, context=context)
        return seq

    def create_more_than_smic_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id
            
        seq += 1
        smic_inter_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': False,
            'category_id': rule_categories['more_smic_categ'],
            'sequence': seq,
            'condition_select': 'none',
            'amount_select': 'code',
            'amount_python_compute': 'result = max((categories.BASIC - (worked_days.WORK100.number_of_hours * config.SMIC.value)), 0)',
        }, context=context)
        if data.employee_rate:
            seq += 1
            more_smic_employee_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employee_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.DEP_SMIC',
                'amount_percentage': data.employee_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employee': True,
            }, context=context)
        if data.employer_rate:
            seq += 1
            more_smic_employer_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employer_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.DEP_SMIC',
                'amount_percentage': data.employer_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employer': True,
            }, context=context)
        return seq

    def create_sup_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        input_obj = self.pool.get('hr.rule.input')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

#        seq += 1
        supp1_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line + ' - ' + _('(Overtime 1)'),
            'name_to_print_on_line': data.name_to_print_on_line + ' - ' + _('(Overtime 1)'),
            'category_id': rule_categories['supp1_categ'],
            'sequence': 2,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.HOURS1 and worked_days.HOURS1.number_of_hours or worked_days.HOURS1_ADJUST and worked_days.HOURS1_ADJUST.number_of_hours',
            'amount_select': 'code',
            'amount_python_compute': 'result = contract.wage\nresult_rate = contract.struct_id.overtime1_rate*100\nresult_qty = (worked_days.HOURS1 and worked_days.HOURS1.number_of_hours or 0) + (worked_days.HOURS1_ADJUST and worked_days.HOURS1_ADJUST.number_of_hours or 0)',
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'hour': True,
        }, context=context)
#        supp1_rule_id = rule_obj.create(cr, uid, {
#            'name': data.name,
#            'code': data.name_to_print_on_line + ' - ' + _('(Overtime 1)'),
#            'name_to_print_on_line': data.name_to_print_on_line + ' - ' + _('(Overtime 1)'),
#            'category_id': rule_categories['supp1_categ'],
#            'sequence': 2,
#            'condition_select': 'python',
#            'condition_python': 'result = inputs.HOURS1.amount',
#            'amount_select': 'code',
#            'amount_python_compute': 'result = contract.wage\nresult_rate = contract.struct_id.overtime1_rate*100\nresult_qty = inputs.HOURS1.amount',
#            'account_debit': account_debit_id,
#            'account_credit': account_credit_id,
#            'account_tax_id': account_tax_id,
#            'hour': True,
#        })
        sup1_nb_categ_id = rule_categories['sup1_nb_categ']
        rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'SUP1_NB',
            'name_to_print_on_line': data.name_to_print_on_line,
            'category_id': sup1_nb_categ_id,
            'sequence': 3,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.HOURS1 and worked_days.HOURS1.number_of_hours or worked_days.HOURS1_ADJUST and worked_days.HOURS1_ADJUST.number_of_hours',
            'amount_select': 'percentage',
            'amount_percentage_base': '(worked_days.HOURS1 and worked_days.HOURS1.number_of_hours or 0) + (worked_days.HOURS1_ADJUST and worked_days.HOURS1_ADJUST.number_of_hours or 0)',
            'amount_percentage': 100,
            'account_debit': False,
            'account_credit': False,
            'appears_on_payslip': False,
        }, context=context)
#        seq += 1
        supp2_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line + ' - ' + _('(Overtime 2)'),
            'name_to_print_on_line': data.name_to_print_on_line + ' - ' + _('(Overtime 2)'),
            'category_id': rule_categories['supp2_categ'],
            'sequence': 4,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.HOURS2 and worked_days.HOURS2.number_of_hours or worked_days.HOURS2_ADJUST and worked_days.HOURS2_ADJUST.number_of_hours',
            'amount_select': 'code',
            'amount_python_compute': 'result = contract.wage\nresult_rate = contract.struct_id.overtime2_rate*100\nresult_qty = (worked_days.HOURS2 and worked_days.HOURS2.number_of_hours or 0) + (worked_days.HOURS2_ADJUST and worked_days.HOURS2_ADJUST.number_of_hours or 0)',
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'hour': True,
        }, context=context)
        sup2_nb_categ_id = rule_categories['sup2_nb_categ']
        rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'SUP2_NB',
            'name_to_print_on_line': data.name_to_print_on_line,
            'category_id': sup2_nb_categ_id,
            'sequence': 5,
            'condition_select': 'python',
            'condition_python': 'result = worked_days.HOURS2 and worked_days.HOURS2.number_of_hours or worked_days.HOURS2_ADJUST and worked_days.HOURS2_ADJUST.number_of_hours',
            'amount_select': 'percentage',
            'amount_percentage_base': '(worked_days.HOURS2 and worked_days.HOURS2.number_of_hours or 0) + (worked_days.HOURS2_ADJUST and worked_days.HOURS2_ADJUST.number_of_hours or 0)',
            'amount_percentage': 100,
            'account_debit': False,
            'account_credit': False,
            'appears_on_payslip': False,
        }, context=context)
#        seq += 1
        sup_inter_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
            'name_to_print_on_line': data.name_to_print_on_line + ' - ' + _('(Intermediate)'),
            'appears_on_payslip': False,
            'category_id': rule_categories['sup_categ'],
            'sequence': 6,
            'condition_select': 'python',
            'condition_python': 'result = categories.SUP1 or categories.SUP2',
            'amount_select': 'code',
            'amount_python_compute': 'result = categories.SUP1 + categories.SUP2\nresult_rate = 100\nresult_qty = 1',
        }, context=context)
        seq += 1

        if data.employee_rate:
            seq += 1
            sup_employee_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employee)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employee_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.INTER_SUP',
                'amount_percentage': data.employee_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employee': True,
            }, context=context)
        if data.employer_rate:
            seq += 1
            sup_employer_id = rule_obj.create(cr, uid, {
                'name': data.name,
                'code': self.update_code(data.name_to_print_on_line,_('(Employer)')),
                'name_to_print_on_line': data.name_to_print_on_line,
                'category_id': employer_categ_id,
                'sequence': seq,
                'condition_select': 'none',
                'amount_select': 'percentage',
                'amount_percentage_base': 'categories.INTER_SUP',
                'amount_percentage': data.employer_rate,
                'account_debit': account_debit_id,
                'account_credit': account_credit_id,
                'account_tax_id': account_tax_id,
                'employer': True,
            }, context=context)
        return seq

    def create_holidays_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            categ_id = rule_categories['ded_categ']
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            categ_id = rule_categories['net_categ']
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        categ_id = rule_categories['holidays_categ']

        rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'HOLIDAYS',
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': True,
            'category_id': categ_id,
            'sequence': 12,
            'condition_select': 'none',
            'amount_select': 'percentage',
            'amount_percentage_base': 'categories.BASIC1',
            'amount_percentage': data.employee_rate,
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'paid_holiday': True,
        }, context=context)
        
        return seq

    def create_expense_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        input_obj = self.pool.get('hr.rule.input')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        categ_id = rule_categories['expense_categ']

        transport_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'TRANSPORT',
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': True,
            'category_id': categ_id,
            'sequence': seq,
            'condition_select': 'python',
            'condition_python': 'result = inputs.TRANSPORT.amount and contract.transport_product_id',
            'amount_select': 'code',
            'amount_python_compute': 'result_rate = inputs.TRANSPORT.amount\nresult = contract.transport_product_id.standard_price\nresult_qty = 1',
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'expense': True,
        }, context=context)
        seq += 1
        input_obj.create(cr, uid, {
                    'name': _('Transport expense'),
                    'code': 'TRANSPORT',
                    'input_id': transport_rule_id
                }, context=context)
        
        return seq

    def create_advance_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        input_obj = self.pool.get('hr.rule.input')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        categ_id = rule_categories['advance_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id

        advance_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': 'ADVANCE',
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': True,
            'category_id': categ_id,
            'sequence': seq,
            'condition_select': 'python',
            'condition_python': 'result = inputs.ADVANCE.amount',
            'amount_select': 'code',
            'amount_python_compute': 'result = -inputs.ADVANCE.amount\nresult_rate = 100\nresult_qty = 1',
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'advance': True,
        }, context=context)
        seq += 1
        input_obj.create(cr, uid, {
                    'name': _('Advance'),
                    'code': 'ADVANCE',
                    'input_id': advance_rule_id
                }, context=context)
        
        return seq
    
#    def create_indemnity_on_gross_rule(self, cr, uid, data, rule_categories, seq, context=None):
#        
#        return False
    
    def create_indemnity_rule(self, cr, uid, data, rule_categories, seq, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
        input_obj = self.pool.get('hr.rule.input')
        account_obj = self.pool.get('account.account')

        account_debit_id = False
        account_credit_id = False
        account_tax_id = False

        if data.deductible:
            employee_categ_id = rule_categories['ded_employee_categ']
            employer_categ_id = rule_categories['ded_employer_categ']
        else:
            employee_categ_id = rule_categories['net_employee_categ']
            employer_categ_id = rule_categories['net_employer_categ']

        if data.debit_account:
            account_debit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.debit_account.code)
                                            ], context=context)
            if account_debit_ids:
                account_debit_id = account_debit_ids[0]

        if data.credit_account:
            account_credit_ids = account_obj.search(cr, uid, [
                                                ('code', '=', data.credit_account.code)
                                            ], context=context)
            if account_credit_ids:
                account_credit_id = account_credit_ids[0]

        if data.account_tax_id:
            account_tax_id = data.account_tax_id.id
        if data.base == 'indemnity':
            categ_id = rule_categories['indemnity_categ']
            indemnity = True
            indemnity_gross = False
            sequence = seq
        else:
            categ_id = rule_categories['indemnity_on_gross_categ']
            indemnity = False
            indemnity_gross = True
            sequence = 14
        code = self.update_code(data.name_to_print_on_line)
        indemnity_rule_id = rule_obj.create(cr, uid, {
            'name': data.name,
            'code': code,
            'name_to_print_on_line': data.name_to_print_on_line,
            'appears_on_payslip': True,
            'category_id': categ_id,
            'sequence': sequence,
            'condition_select': 'python',
            'condition_python': 'result = inputs.' + code + ' and inputs.' + code + '.amount',
            'amount_select': 'code',
            'amount_python_compute': 'result_rate = 100\nresult = inputs.' + code + '.amount\nresult_qty = 1',
            'account_debit': account_debit_id,
            'account_credit': account_credit_id,
            'account_tax_id': account_tax_id,
            'indemnity': indemnity,
            'indemnity_gross': indemnity_gross,
        }, context=context)
        seq += 1
        input_obj.create(cr, uid, {
                    'name': data.name_to_print_on_line,
                    'code': code,
                    'input_id': indemnity_rule_id
                }, context=context)
        
        return seq
    
    def get_rules_to_unactivate(self, cr, uid, data, context=None):
        rule_obj = self.pool.get('hr.salary.rule')
        return rule_obj.search(cr, uid, [
                    ('name', 'in', (data.name, _('Adjustment ') + data.name))
                ], context=context)

    def unactive_rule(self, cr, uid, data, context=None):
        if context is None:
            context = {}

        rule_obj = self.pool.get('hr.salary.rule')
#        input_obj = self.pool.get('hr.rule.input')

#        rule_unlink_ids = []
        rule_ids = self.get_rules_to_unactivate(cr, uid, data, context=context)

#        for rule in rule_obj.browse(cr, uid, rule_ids, context=context):
#            rule_unlink_ids.append(rule.id)
#            if rule.input_ids:
#                input_unlink_ids = []
#                for input in rule.input_ids:
#                    input_unlink_ids.append(input.id)
#                if input_unlink_ids:
#                    input_obj.unlink(cr, uid, input_unlink_ids, context=context)
        rule_unlink_ids = rule_ids
        if rule_unlink_ids:
            rule_obj.write(cr, uid, rule_unlink_ids, {
                        'active':False
                    }, context=context)
        return True
    
    def create_rules(self, cr, uid, data, rule_categories, seq, context=None):
        if data.base == 'brut':
            seq = self.create_brut_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'normal':
            seq = self.create_normal_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base in ['ss', 'ss4']:
            seq = self.create_csg_ss(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'smic':
            seq = self.create_smic_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'more_than_smic':
            seq = self.create_more_than_smic_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'sup':
            seq = self.create_sup_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'paid_holiday':
            seq = self.create_holidays_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'csg':
            seq = self.create_csg_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'expense':
            seq = self.create_expense_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'advance':
            seq = self.create_advance_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'indemnity':
            seq = self.create_indemnity_rule(cr, uid, data, rule_categories, seq, context=context)
        elif data.base == 'indemnity_gross':
            seq = self.create_indemnity_rule(cr, uid, data, rule_categories, seq, context=context)
        return seq
    
    def get_structure_vals(self, cr, uid, salary_data, rule_ids, context=None):
        rule_dict = {}.fromkeys(rule_ids)
        rule_ids = rule_dict.keys()
        return {
            'name': salary_data.name + ' ' + _('Salary Structure'),
            'code': salary_data.name,
            'parent_id': False,
            'type_id': salary_data.id,
            'hours_a_week': salary_data.hours_a_week,
            'overtime1': 8,
            'overtime1_rate': salary_data.sup1_rate,
            'overtime2_rate': salary_data.sup2_rate,
            'holiday_a_month': salary_data.holiday_a_month,
            'rule_ids': [(6, 0, rule_ids)],
            'company_id': salary_data.company_id.id,
        }
        
    def get_rules(self, cr, uid, rule, context=None):
        rule_obj = self.pool.get('hr.salary.rule')
        return rule_obj.search(cr, uid, [
                            ('name', 'in', (rule.name,_('Adjustment ')+rule.name))
                        ], context=context)
    
    def get_default_rules(self, cr, uid, salary_data, context=None):
        model_data_obj = self.pool.get('ir.model.data')
        basic1_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_basic1')
        basic1_rule_id = model_data_obj.browse(cr, uid, basic1_rule).res_id
        basic_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_basic')
        basic_rule_id = model_data_obj.browse(cr, uid, basic_rule).res_id
        total_nb_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_total_nb')
        total_nb_rule_id = model_data_obj.browse(cr, uid, total_nb_rule).res_id
        ded_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_ded')
        ded_rule_id = model_data_obj.browse(cr, uid, ded_rule).res_id
        net_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_net')
        net_rule_id = model_data_obj.browse(cr, uid, net_rule).res_id
        ss_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_ss')
        ss_rule_id = model_data_obj.browse(cr, uid, ss_rule).res_id
        ss4_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_ss4')
        ss4_rule_id = model_data_obj.browse(cr, uid, ss4_rule).res_id
        smic_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_smic')
        smic_rule_id = model_data_obj.browse(cr, uid, smic_rule).res_id
        dep_smic_rule = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration', 'hr_configuration_rule_dep_smic')
        dep_smic_rule_id = model_data_obj.browse(cr, uid, dep_smic_rule).res_id
        return [basic1_rule_id, basic_rule_id, total_nb_rule_id, ded_rule_id, net_rule_id, ss_rule_id, ss4_rule_id, smic_rule_id, dep_smic_rule_id]

    def convert_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}

        cotisation_obj = self.pool.get('account.cotisation')
        salary_type_obj = self.pool.get('account.salary.type')
        model_data_obj = self.pool.get('ir.model.data')
        strucutre_obj = self.pool.get('hr.payroll.structure')
        rule_obj = self.pool.get('hr.salary.rule')
        
        current_obj = self.browse(cr, uid, ids[0], context=context)
        company_id = current_obj.company_id and current_obj.company_id.id or False
        seq = 150
        rule_categories = self.get_categories(cr, uid, context=context)
        cotisation_ids = cotisation_obj.search(cr, uid,
            ['|', ('company_id', '=', company_id), ('company_id', '=', False)], context=context)

        for data in cotisation_obj.browse(cr, uid, cotisation_ids, context=context):
            self.unactive_rule(cr, uid, data, context=context)
            self.create_rules(cr, uid, data, rule_categories, seq, context=context)

        salary_type_ids = salary_type_obj.search(cr, uid,
            [('company_id', '=', company_id)], context=context)
        for salary_data in salary_type_obj.browse(cr, uid, salary_type_ids, context=context):
            rule_ids = self.get_default_rules(cr, uid, salary_data, context=context)
            for rule in salary_data.cotisation:
                rule_ids.extend(self.get_rules(cr, uid, rule, context=context))
            structure_ids = strucutre_obj.search(cr, uid, [
                                    ('type_id', '=', salary_data.id)
                                ], context=context)
            structure_vals = self.get_structure_vals(cr, uid, salary_data, rule_ids, context=context)
            if not structure_ids:
                strucutre_obj.create(cr, uid, structure_vals, context=context)
            else:
                strucutre_obj.write(cr, uid, structure_ids, structure_vals, context=context)
#            structure_unlink_ids = strucutre_obj.search(cr, uid, [('code', '=', salary_data.name)])
#            if structure_unlink_ids:
#                strucutre_obj.unlink(cr, uid, structure_unlink_ids, context=context)
#            strucutre_obj.create(cr, uid, {
#                            'name': salary_data.name + ' ' + 'Salary Structure',
#                            'code': salary_data.name,
#                            'parent_id': False,
#                            'rule_ids': [(6, 0, rule_ids)]
#                        })
        model_data_ids = model_data_obj.search(cr, uid,[
                            ('model', '=', 'ir.ui.view'),
                            ('name', '=', 'view_hr_message')
                        ], context=context)
        resource_id = model_data_obj.read(cr, uid, model_data_ids, fields=['res_id'], context=context)[0]['res_id']
        return {
                'name': _('Data Import'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'hr.message',
                'views': [(resource_id, 'form')],
                'type': 'ir.actions.act_window',
                'target': 'new',
                'nodestroy': False
            }

hr_payroll_configuration()

class hr_payroll_structure(osv.osv):

    _inherit = 'hr.payroll.structure'
    
    _columns = {
        'type_id': fields.many2one('account.salary.type', 'Related salary type'),
        'hours_a_week': fields.float('Hours worked a week'),
        'overtime1': fields.float('Overtime 1 max'),
        'overtime1_rate': fields.float('Overtime 1 rate'),
        'overtime2_rate': fields.float('Overtime 2 rate'),
        'holiday_a_month': fields.float('Base Holiday acquired by month')
    }

hr_payroll_structure()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: