# -*- coding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2012 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

from osv import osv, fields
from tools.translate import _
from addons.hr_payroll_configuration.hr_payroll import SELECTION_LIST

SELECTION_LIST += [
    ('reduction', 'Reduction'),
    ('025brut', '0,25 X Gross Salary'),
]

class account_cotisation(osv.osv):
    _description = 'Cotisations'
    _inherit = 'account.cotisation'
    _columns = {
        'base' : fields.selection(SELECTION_LIST, 'Base'),
      }

account_cotisation()

class hr_payslip(osv.osv):
    _inherit = 'hr.payslip'
    
    def get_config_dict(self, cr, uid, context=None):
        account_config_dict = super(hr_payslip, self).get_config_dict(cr, uid, context=context)
        account_config_obj = self.pool.get('account.salary.config')
        model_data_obj = self.pool.get('ir.model.data')

        reduction_categ = model_data_obj._get_id(cr, uid, 'hr_payroll_configuration_l10n_fr', 'config_reduction_fillon')
        account_config_id = model_data_obj.browse(cr, uid, reduction_categ).res_id
        account_config_dict['REDUCTION'] = account_config_obj.browse(cr, uid, account_config_id, context=context)
        
        return account_config_dict

hr_payslip()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
